<?php
// $Id: discogs.views.inc,v 1.1 2011/01/19 16:15:56 karlheinz Exp $
/**
 * @file
 * Views integration for Discography module.
 */

/**
 * Implementation of hook_views_data().
 */

function discogs_views_data() {
  $data = array();

  // discogs table definition
  $data['discogs']['table']['group'] = t('Discography');
  $data['discogs']['table']['join']  = array(
    'node_revisions' => array(
      'left_field' => 'vid',
      'field' => 'vid',
    ),
    'node' => array(
      'left_field' => 'vid',
      'field' => 'vid',
    ),
  );

  // discogs.did
  $data['discogs']['did'] = array(
    'title' => t('Did'),
    'help' => t('Discogs.com ID'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  // discogs.discog_artist
  $data['discogs']['discog_artist'] = array(
    'title' => t('Artist'),
    'help' => t('Discography artist.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
       'handler' => 'views_handler_argument_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  // discogs.discog_label
  $data['discogs']['discog_label'] = array(
    'title' => t('Label'),
    'help' => t('Label or publisher.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
       'handler' => 'views_handler_argument_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  // discogs.discog_cat_num
  $data['discogs']['discog_label'] = array(
    'title' => t('Cat_num'),
    'help' => t('Catalogue number.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
       'handler' => 'views_handler_argument_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  // discogs.discog_format
  $data['discogs']['discog_format'] = array(
    'title' => t('Format'),
    'help' => t('Discography release format.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
       'handler' => 'views_handler_argument_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  // discogs.discog_country
  $data['discogs']['discog_country'] = array(
    'title' => t('Country'),
    'help' => t('Discography release country.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
       'handler' => 'views_handler_argument_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  // discogs.discog_date
  $data['discogs']['discog_date'] = array(
    'title' => t('Date'),
    'help' => t('Discography release date.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
       'handler' => 'views_handler_argument_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  // Native image handling
  $data['discogs']['discog_img'] = array(
    'title' => t('Image'),
    'help' => t('Discography image.'),
    'field' => array(
      'handler' => 'discogs_handler_field_discogs_img',
    ),
  );

  return $data;
}

/**
 * Implementation of hook_views_handlers().
 */
function discogs_views_handlers() {
    return array(
    'info' => array(
      'path' => drupal_get_path('module', 'discogs') . '/views',
    ),
    'handlers' => array(
      'discogs_handler_field_discogs_img' => array(
        'parent' => 'views_handler_field',
      ),
    ),
  );
}

/**
 * Implementation of hook_views_pre_build().
 */
function discogs_views_pre_build(&$view) {
  // Unset view handler if we're not using native image handling
  if (variable_get('discogs_img_handler', 0)) {
    unset($view->display['default']->handler->options['fields']['discog_img']);
  }
}